/** Light Saver plugin User Interface Interactions
 *
 * @author Andrea B.
 *
 * @required <a href="http://jquery.com/">jQuery</a>
 * @required <a href="http://jqueryui.com/">jQuery UI</a>
 */
"use strict";

/** On ready operations */
$(function() {
    var promises = [];
    var dataNotFoundComponent = new Array();
    var seriesToShow = new Array();
    var componentDataToCsv = new Array();

    //set threhold value
    $("#threshold").on("keyup", function(e) {

        var threshold = $("#threshold").val().trim();
        if (threshold == PLUGIN_CONFIG.threshold || threshold.charAt(threshold.length - 1) == '.')
            return;

        if (threshold.trim() == '')
            threshold = '0';

        if (threshold !== undefined && threshold != '') {
            $.ajax({
                dataType: "json",
                url: URL_DATA,
                data: {
                    id: 'Recorder_Base',
                    params: 'threshold|' + threshold + '|'
                },
                cache: false,

                error: function(qXHR, textStatus, errorThrown) {
                    console.debug(qXHR);
                    console.debug(textStatus);
                    console.debug(errorThrown);
                },

                success: function(json) {
                    if (json.saveStatus == 'ok')
                        PLUGIN_CONFIG.threshold = threshold;
                    else
                        console.error('Error saving threshold');
                }
            });
        }
    });


    $("#refresh").on("click", function(e) {

        var $listElements = $("#components").find("form ul li");
        if ($listElements.length > 0) {
            $("#components form").submit();
        }

    });

    /** Select components */
    $("#components").on("change", "#select-components", function(e) {

        var $listElements = $("#components").find("form ul li");

        for (var i = 0; i < $listElements.length; ++i) {
            var $currentElement = $($listElements[i]);
            if ($currentElement.attr("component-id") == $("#select-components option:selected").val())
                return;
        }

        var userFromDate = $("#components").find(".inputFromDate").val();
        var userToDate = $("#components").find(".inputToDate").val();

        //var userToDate
        //$("#components").find("form ul").empty();
        $("#component-stats").empty();
        $("#show-status").hide();
        $("#component-more-stats").empty();
        $("#component-stats").append('<p style="text-align:center">Loading...</p>');

        var currentDate = new Date();
        var defaultDateInterval = new Date();

        //default date interval
        //defaultDateInterval.setTime(defaultDateInterval.getTime() - (7*24*60*60*1000)); //one week
        defaultDateInterval.setTime(defaultDateInterval.getTime() - (2 * 24 * 60 * 60 * 1000)); // 2 days

        //var currentDateToString = currentDate.getFullYear() + "-" + currentDate.getMonth() + 1 + "-" + currentDate.getDate(); //english date format
        var currentDateToString = zeroPad(currentDate.getDate(), 2) + "-" + zeroPad(parseInt(currentDate.getMonth() + 1), 2) + "-" + currentDate.getFullYear(); //italian date format

        var defaultDateIntervalToString = zeroPad(defaultDateInterval.getDate(), 2) + "-" + zeroPad(parseInt(defaultDateInterval.getMonth() + 1), 2) + "-" + defaultDateInterval.getFullYear();
        var $this = $(this);
        var $selected = $this.find(":selected");
        var $li = $("<li></li>");
        var $category = $("<span></span>");
        var $description = $("<span></span>");
        var $labelFromDate = $("<span>From date: </span>");
        if (userFromDate !== undefined && userToDate !== undefined) {
            var $inputFromDate = $("<input type='text'  value='" + userFromDate + "'></input>");
            var $labelToDate = $("<span>To date: </span>");
            var $inputToDate = $("<input type='text'  value='" + userToDate + "'></input>");
        } else {
            var $inputFromDate = $("<input type='text'  value='" + defaultDateIntervalToString + "'></input>");
            var $labelToDate = $("<span>To date: </span>");
            var $inputToDate = $("<input type='text'  value='" + currentDateToString + "'></input>");
        }

        var $labelScale = $("<span>Scale: </span>");
        var $inputScale = $("<input type='text'  value='1' ></input>");

        var $remove = $("<span>&nbsp;</span>");
        var oData = $selected.data("myReference"); // in data ho il componente

        console.log(oData);



        var customData = jQuery.parseJSON(oData.customData);
        console.log(customData.plugin);
        var plugin = customData.plugin;
        if (oData !== undefined) {


            var titlex = ""
            var title = ""

            if (oData["title"].indexOf("|") >= 0) {
                titlex = oData["title"].split("|");
                if (titlex[0] != "") {
                    title = titlex[0];
                    if (titlex[1] != undefined && titlex[1] != "") title += " - " + titlex[1];
                }


            } else {
                title = oData["title"];
            }

            $description.text(title);

            $category.text(oData["category"]);
            $remove.addClass("remove").addClass("ui-icon").addClass("ui-icon-circle-close");

            $description.addClass("name");
            $category.addClass("category");

            $inputFromDate.addClass("inputFromDate");
            $inputToDate.addClass("inputToDate");
            $labelFromDate.addClass("labelFromDate");
            $labelToDate.addClass("labelToDate");

            $labelScale.addClass("labelScale");
            $inputScale.addClass("inputScale");


            $li.attr("title", oData["name"]);
            $li.attr("component-id", oData.id);
            //		$li.append($category).append($description).append($labelFromDate).append($inputFromDate).append($labelToDate).append($inputToDate).append($remove);
            $li.append($description).append($labelFromDate).append($inputFromDate).append($labelToDate).append($inputToDate).append($labelScale).append($inputScale).append($remove);
            $li.append("<br>");

            if (plugin == "powermeter") {
                $li.append("<span dictionary='Active energy' style='margin-right:10px;margin-left:30px;'>Active energy</span><input id='" + oData.id + "-AE' type='checkbox' value='false' style='vertical-align:top' />");
                $li.append("<span dictionary='Reactive energy' style='margin-right:10px;margin-left:30px;'>Rective energy</span><input id='" + oData.id + "-RE' type='checkbox' value='false' style='vertical-align:top' />");
                $li.append("<span dictionary='Active power' style='margin-right:10px;margin-left:30px;'>Active power</span><input id='" + oData.id + "-AP' type='checkbox' value='false' style='vertical-align:top' />");
                $li.append("<span dictionary='Reactive power' style='margin-right:10px;margin-left:30px;'>Reactive power</span><input id='" + oData.id + "-RP' type='checkbox' value='false' style='vertical-align:top' />");
                $li.append("<span dictionary='Power factor (cos phy)' style='margin-right:10px;margin-left:30px;'>Power factor (cos )</span><input id='" + oData.id + "-PHY' type='checkbox' value='false' style='vertical-align:top' />");
            }



            $("#components").find("form ul").append($li);
            $li.data("component", oData);
            if (plugin == "powermeter") {

                if (customData.activeenergy == "None") $("#" + oData.id + "-AE").attr("disabled", true);
                if (customData.reactiveenergy == "None") $("#" + oData.id + "-RE").attr("disabled", true);
                if (customData.activepower == "None") $("#" + oData.id + "-AP").attr("disabled", true);
                if (customData.reactivepower == "None") $("#" + oData.id + "-RP").attr("disabled", true);
                if (customData.cosphy == "None") $("#" + oData.id + "-PHY").attr("disabled", true);
            }

            $(".inputFromDate").datepicker({
                //dateFormat : 'yy-mm-dd' //english date format
                dateFormat: 'dd-mm-yy', //italian date format
                /*			onSelect : function() {
                				$("#components form").submit(); 
                			}
                	*/
            });
            $(".inputToDate").datepicker({
                //dateFormat : 'yy-mm-dd' //english date format
                dateFormat: 'dd-mm-yy', //italian date format
                /*	onSelect : function() {
                		$("#components form").submit();
                	}*/
            });

            //	$("#components form").submit();
            //submit form at onchange event of #select-components
        }

        $("#select-components option:first").attr('selected', 'selected');
    });

    /** Select component form*/
    $("#components").on("submit", "form", function(e) {

        // Create a timer, for chat subtitle "chart built in ..."
        var start = +new Date();

        $("#show-status").hide();
        $("#component-stats").empty();
        $("#component-stats").append('<p style="text-align:center">Loading...</p>');
        $("#component-more-stats").empty();

        var $this = $(this);
        var parameters = "";

        seriesToShow = new Array();
        componentDataToCsv = new Array();
        var $listElements = $("#components").find("form ul li");
        if ($listElements.length > 0) {
            promises = [];
            dataNotFoundComponent = new Array();
            for (var i = 0; i < $listElements.length; ++i) {
                var $currentElement = $($listElements[i]);
                var oData = $currentElement.data("component");
                var customData = jQuery.parseJSON(oData.customData);
                if (customData.plugin == "powermeter") {
                    if ($("#" + oData.id + "-AE").is(':checked')) {
                        var fromDate = $currentElement.find(".inputFromDate").val();
                        fromDate = fromDate.substring(6) + "-" + fromDate.substring(3, 5) + "-" + fromDate.substring(0, 2);
                        var toDate = $currentElement.find(".inputToDate").val();
                        toDate = toDate.substring(6) + "-" + toDate.substring(3, 5) + "-" + toDate.substring(0, 2);
                        var viewmode = $("input[name=viewmode]:checked").val();
                        var scale = $currentElement.find(".inputScale").val();
                        parameters = "EVEInfo" + customData.activeenergy + '|' + fromDate + '|' + toDate + '|' + viewmode + '|' + scale;
                        var title = $currentElement.attr("title");
                        requestChart(parameters);
                    };

                    if ($("#" + oData.id + "-AP").is(':checked')) {
                        var fromDate = $currentElement.find(".inputFromDate").val();
                        fromDate = fromDate.substring(6) + "-" + fromDate.substring(3, 5) + "-" + fromDate.substring(0, 2);
                        var toDate = $currentElement.find(".inputToDate").val();
                        toDate = toDate.substring(6) + "-" + toDate.substring(3, 5) + "-" + toDate.substring(0, 2);
                        var viewmode = $("input[name=viewmode]:checked").val();
                        var scale = $currentElement.find(".inputScale").val();
                        parameters = "EVEInfo" + customData.activepower + '|' + fromDate + '|' + toDate + '|' + viewmode + '|' + scale;
                        var title = $currentElement.attr("title");
                        requestChart(parameters);
                    };

                    if ($("#" + oData.id + "-RE").is(':checked')) {
                        var fromDate = $currentElement.find(".inputFromDate").val();
                        fromDate = fromDate.substring(6) + "-" + fromDate.substring(3, 5) + "-" + fromDate.substring(0, 2);
                        var toDate = $currentElement.find(".inputToDate").val();
                        toDate = toDate.substring(6) + "-" + toDate.substring(3, 5) + "-" + toDate.substring(0, 2);
                        var viewmode = $("input[name=viewmode]:checked").val();
                        var scale = $currentElement.find(".inputScale").val();
                        parameters = "EVEInfo" + customData.reactiveenergy + '|' + fromDate + '|' + toDate + '|' + viewmode + '|' + scale;
                        var title = $currentElement.attr("title");
                        requestChart(parameters);
                    };

                    if ($("#" + oData.id + "-RP").is(':checked')) {
                        var fromDate = $currentElement.find(".inputFromDate").val();
                        fromDate = fromDate.substring(6) + "-" + fromDate.substring(3, 5) + "-" + fromDate.substring(0, 2);
                        var toDate = $currentElement.find(".inputToDate").val();
                        toDate = toDate.substring(6) + "-" + toDate.substring(3, 5) + "-" + toDate.substring(0, 2);
                        var viewmode = $("input[name=viewmode]:checked").val();
                        var scale = $currentElement.find(".inputScale").val();
                        parameters = "EVEInfo" + customData.reactivepower + '|' + fromDate + '|' + toDate + '|' + viewmode + '|' + scale;
                        var title = $currentElement.attr("title");
                        requestChart(parameters);
                    };

                    if ($("#" + oData.id + "-PHY").is(':checked')) {
                        var fromDate = $currentElement.find(".inputFromDate").val();
                        fromDate = fromDate.substring(6) + "-" + fromDate.substring(3, 5) + "-" + fromDate.substring(0, 2);
                        var toDate = $currentElement.find(".inputToDate").val();
                        toDate = toDate.substring(6) + "-" + toDate.substring(3, 5) + "-" + toDate.substring(0, 2);
                        var viewmode = $("input[name=viewmode]:checked").val();
                        var scale = $currentElement.find(".inputScale").val();
                        parameters = "EVEInfo" + customData.cosphy + '|' + fromDate + '|' + toDate + '|' + viewmode + '|' + scale;
                        var title = $currentElement.attr("title");
                        requestChart(parameters);
                    };

                    /*			if (customData.reactiveenergy=="None") $("#"+oData.id+"-RE").attr("disabled", true);
                    			if (customData.activepower=="None") $("#"+oData.id+"-AP").attr("disabled", true);
                    			if (customData.reactivepower=="None") $("#"+oData.id+"-RP").attr("disabled", true);
                    			if (customData.cosphy=="None") $("#"+oData.id+"-PHY").attr("disabled", true);
                    	*/
                } else {
                    var fromDate = $currentElement.find(".inputFromDate").val();
                    fromDate = fromDate.substring(6) + "-" + fromDate.substring(3, 5) + "-" + fromDate.substring(0, 2);
                    var toDate = $currentElement.find(".inputToDate").val();
                    toDate = toDate.substring(6) + "-" + toDate.substring(3, 5) + "-" + toDate.substring(0, 2);
                    var viewmode = $("input[name=viewmode]:checked").val();
                    var scale = $currentElement.find(".inputScale").val();
                    parameters = $currentElement.attr("component-id") + '|' + fromDate + '|' + toDate + '|' + viewmode + '|' + scale;
                    var title = $currentElement.attr("title");
                    requestChart(parameters);
                }




            }
            $.when.apply(null, promises).done(function() {
                createChart(start, seriesToShow, dataNotFoundComponent, componentDataToCsv);
            });
        } else {
            $("#component-stats").empty();
            $("#component-more-stats").empty();
            var $status = $("#show-status");
            $status.text("Data not found");
            $("#show-status").show();
        }
    });

    $("#components").on("click", ".remove", function(e) {
        $(this).parents("li").remove();
        //	$("#components form").submit();
        var $listElements = $("#components").find("form ul li");
        if ($listElements.length == 0) {
            $("#show-status").hide();
        }
    });




    function createCsv(componentDataToCsv) {

        var $listElements = $("#components").find("form ul li");
        if ($listElements.length > 0) {
            var $currentElement = $($listElements[0]);
            var title = $currentElement.attr("title");

            var csvFileName = title + ".csv";
            $.ajax({
                url: "./utils/json2csv.php",
                type: "POST",
                cache: false,
                data: {
                    json: JSON.stringify(componentDataToCsv),
                    fileName: csvFileName
                },

                error: function(qXHR, textStatus, errorThrown) {
                    console.debug(qXHR);
                    console.debug(textStatus);
                    console.debug(errorThrown);
                },

                success: function(data) {
                    $("#component-more-stats").append("<a href='./utils/csv/" + csvFileName + "'><span id='download-csv' style='color: blue;'>Download csv</span></a>");
                }
            });
        }




    }

    function createChart(start, seriesToShow, dataNotFoundComponent, componentDataToCsv) {

        /*var dataNotFoundTitle='';
        if(dataNotFoundComponent !== undefined && dataNotFoundComponent != null && dataNotFoundComponent.length > 0) {
        	dataNotFoundTitle='Data not found: ';
        	for(var i=0; i<dataNotFoundComponent.length; i++) {
        		dataNotFoundTitle = dataNotFoundTitle + dataNotFoundComponent[i].trim();
        	}
        	$("#component-stats").empty();
        	$("#component-stats").append('<p style="text-align:center">'+dataNotFoundTitle+'</p>');
        	$("#component-more-stats").empty();
        }
        */
        if (seriesToShow.length == 0) {
            $("#component-stats").empty();
            $("#component-more-stats").empty();
            var $status = $("#show-status");
            $status.text("Data not found");
            $("#show-status").show();
            return;
        }


        // Create the chart
        $('#component-stats').highcharts('StockChart', {
            chart: {
                events: {
                    load: function(chart) {
                        /*this.setTitle(null, {
                        	text : 'Chart built in ' + (new Date() - start) + 'ms'
                        });*/
                    }
                },
                zoomType: 'x'
            },
            rangeSelector: {
                buttons: [{
                    type: 'day',
                    count: 1,
                    text: '1d'
                }, {
                    type: 'week',
                    count: 1,
                    text: '1w'
                }, {
                    type: 'month',
                    count: 1,
                    text: '1m'
                }, {
                    type: 'month',
                    count: 6,
                    text: '6m'
                }, {
                    type: 'year',
                    count: 1,
                    text: '1y'
                }, {
                    type: 'all',
                    text: 'All'
                }],
                selected: 3,
                inputEnabled: false
            },

            yAxis: {
                title: {
                    text: ''
                }
            },
            xAxis: {
                ordinal: false,
                //minRange: 1000,
            },

            title: {
                text: ''
            },

            subtitle: {
                //text : 'Chart built in...' // dummy text to reserve space for dynamic subtitle
                text: ''
            },

            legend: {
                enabled: true
            },

            credits: {
                enabled: false
            },

            maxZoom: 1000,
            series: seriesToShow

        });

        createCsv(componentDataToCsv);
    }

    function ms2Time(ms) {
        if (ms < 1)
            return "00:00:00 hh:mm:ss";
        var secs = ms / 1000;
        ms = Math.floor(ms % 1000);
        var minutes = secs / 60;
        secs = Math.floor(secs % 60);
        var hours = minutes / 60;
        minutes = Math.floor(minutes % 60);
        hours = Math.floor(hours % 24);
        if (hours < 10)
            hours = '0' + hours;
        if (minutes < 10)
            minutes = '0' + minutes;
        if (secs < 10)
            secs = '0' + secs;

        return hours + ":" + minutes + ":" + secs;
    }

    function zeroPad(num, count) {
        var numZeropad = num + '';
        while (numZeropad.length < count) {
            numZeropad = "0" + numZeropad;
        }
        return numZeropad;
    }

    /** Select components threshold*/
    $("#settings").on("change", "#select-components-threshold", function(e) {
        var $this = $(this);
        var $selected = $this.find(":selected");

        var $li = $("<li></li>");
        var $category = $("<span></span>");
        var $description = $("<span></span>");
        var $input = $("<input type='text' value='1' onkeypress='bigh.onlyPosFloat();'></input>");
        var $remove = $("<span>&nbsp;</span>");

        var oData = $selected.data("myThresholdReference");

        if (oData !== undefined) {

            //prevent same component append
            for (var i = 0; i < PLUGIN_CONFIG.componentThresholds.length; i++) {
                if (PLUGIN_CONFIG.componentThresholds[i].uid == oData.id)
                    return;
            }

            $description.text(oData["name"]);
            $category.text(oData["category"]);
            $description.addClass("name");
            $category.addClass("category");
            $input.addClass("inputThreshold");
            $remove.addClass("removeThreshold").addClass("ui-icon").addClass("ui-icon-circle-close");
            $li.attr("title", oData["name"]);
            $li.attr("component-id", oData.id);

            $li.append($category).append($description).append($input).append($remove);

            $("#thresholds").append($li);

            var compSettings = {
                uid: oData.id,
                name: oData.name,
                category: oData.category,
                threshold: '1'
            };

            PLUGIN_CONFIG.componentThresholds.push(compSettings);
            savePluginConfig();
            /*if (!saveDone) {
            	var $status = $("#save-switches-status");
            	$status.text("error saving");
            	$("#save-switches-status").show().fadeToggle(4000);
            }*/
            $("#select-components-threshold option:first").attr('selected', 'selected');
        }

    });

    $("#thresholds").on("keyup", ".inputThreshold", function(e) {

        var uid = $(this).parents("li").attr("component-id");
        var threshold = $(this).val();

        if (PLUGIN_CONFIG !== undefined && PLUGIN_CONFIG != null) {
            for (var i = 0; i < PLUGIN_CONFIG.componentThresholds.length; i++) {
                if (PLUGIN_CONFIG.componentThresholds[i].uid == uid) {
                    PLUGIN_CONFIG.componentThresholds[i].threshold = threshold;
                    break;
                }
            }
        }
        savePluginConfig();
        /*if (!saveDone) {
        	var $status = $("#save-switches-status");
        	$status.text("error saving");
        	$("#save-switches-status").show().fadeToggle(4000);
        }*/
    });

    /** Remove component threshold */
    $("#thresholds").on("click", ".removeThreshold", function(e) {
        var uid = $(this).parents("li").attr("component-id");

        if (PLUGIN_CONFIG !== undefined && PLUGIN_CONFIG != null) {
            for (var i = 0; i < PLUGIN_CONFIG.componentThresholds.length; i++) {
                if (PLUGIN_CONFIG.componentThresholds[i].uid == uid) {
                    PLUGIN_CONFIG.componentThresholds.splice(i, 1);
                    break;
                }
            }
        }

        savePluginConfig();
        if (saveDone)
            $(this).parents("li").remove();
        /*else {
        	var $status = $("#save-switches-status");
        	$status.text("error saving");
        	$("#save-switches-status").show().fadeToggle(4000);
        }*/
    });

    function savePluginConfig() {

        if (PLUGIN_CONFIG !== undefined && PLUGIN_CONFIG != null) {
            $.ajax({
                url: URL_OUT,
                type: "post",
                data: { config: JSON.stringify(PLUGIN_CONFIG), comp: 'Recorder_Base' },
                dataType: "text",
                success: function(json) {
                    saveDone = true;
                },
                error: function(json) {
                    saveDone = false;
                }
            });
        }
        return saveDone;
    }


    function requestChart(parameters, title) {


        var request = $.ajax({
            dataType: "json",
            url: URL_DATA,
            data: {
                id: 'Recorder_Base',
                params: parameters
            },
            cache: false,

            error: function(qXHR, textStatus, errorThrown) {
                console.debug(qXHR);
                console.debug(textStatus);
                console.debug(errorThrown);
            },

            success: function(json) {

                if (json.stats.length == 0) {
                    dataNotFoundComponent.push(title);
                    /*var $choosenComponents = $("#components").find("form ul li");
							if($choosenComponents.length == 1) {
								//seriesToShow.push({});
								$("#component-stats").empty();
								var $status = $("#show-status");
								$status.text("Data not found");
								$("#show-status").show();						
							} else {
								//if no data an empty serie is created
								var emptySerie = {
									name : title,
									pointInterval : 3600 * 1000,
									tooltip : {
										valueSuffix : ''
									},
									dataGrouping : {
										enabled : false
									},
									data : new Array()
		
								};
								seriesToShow.push(emptySerie);
								var $status = $("#show-status");
								$status.text(title + ": data not found");
								$("#show-status").show();	
							}*/
                } else {
                    var statsArray = new Array();
                    var previous = 0;

                    for (var i = 0; i < json.stats.length; i++) {
                        //chart
                        var elem = new Array();
                        var chti = json.stats[i].change_time;
                        //console.log(chti);
                        elem[0] = Date.UTC(chti.substring(6, 10), chti.substring(3, 5) - 1, chti.substring(0, 2), chti.substring(11, 13), chti.substring(14, 16), chti.substring(17));

                        //elem[1] = parseFloat(json.stats[i].value);  string = string.replace(/[^0-9.]+/g, '');
                        elem[1] = previous;

                        statsArray.push(elem);
                        var elem = new Array();

                        elem[0] = Date.UTC(chti.substring(6, 10), chti.substring(3, 5) - 1, chti.substring(0, 2), chti.substring(11, 13), chti.substring(14, 16), chti.substring(17));

                        //elem[1] = parseFloat(json.stats[i].value);  string = string.replace(/[^0-9.]+/g, '');
                        elem[1] = parseFloat(json.stats[i].value.replace(/[^0-9.-]+/g, ''));

                        previous = elem[1];
                        statsArray.push(elem);
                        //csv
                        var obj = {
                            name: title,
                            value: json.stats[i].value,
                            date: json.stats[i].change_time
                        };
                        componentDataToCsv.push(obj);

                    }
                    //console.log(componentDataToCsv);	

                    var t = json.title;
                    if (t == "") t = json.info

                    var singleSerie = {
                        name: json.info, // json.stats[0].parameterName.trim(),

                        //name : json.stats[0].parameterName.trim(),
                        pointInterval: 3600 * 1000,
                        tooltip: {
                            valueSuffix: json.stats[0].value.replace(/[0-9.-]+/g, '')
                        },
                        dataGrouping: {
                            enabled: false
                        },
                        data: statsArray

                    };
                    seriesToShow.push(singleSerie);

                }

                /*if (seriesToShow.length == $listElements.length) {
                	createChart(start, seriesToShow);
                	createCsv(componentDataToCsv);
                }*/
            }
        });
        promises.push(request);
    }

    $("#exportdatatoexcel").click(function() {
        // Create a timer, for chat subtitle "chart built in ..."
        var start = +new Date();

        $("#show-status").hide();
        $("#component-stats").empty();
        $("#component-stats").append('<p style="text-align:center">Loading...</p>');
        $("#component-more-stats").empty();

        var $this = $(this);
        var parameters = [{ "action": "export" }];

        seriesToShow = new Array();
        componentDataToCsv = new Array();
        var $listElements = $("#components").find("form ul li");
        if ($listElements.length > 0) {

            dataNotFoundComponent = new Array();
            for (var i = 0; i < $listElements.length; ++i) {
                var $currentElement = $($listElements[i]);
                var oData = $currentElement.data("component");
                var customData = jQuery.parseJSON(oData.customData);
                if (customData.plugin == "powermeter") {
                    if ($("#" + oData.id + "-AE").is(':checked')) {
                        var fromDate = $currentElement.find(".inputFromDate").val();
                        fromDate = fromDate.substring(6) + "-" + fromDate.substring(3, 5) + "-" + fromDate.substring(0, 2);
                        var toDate = $currentElement.find(".inputToDate").val();
                        toDate = toDate.substring(6) + "-" + toDate.substring(3, 5) + "-" + toDate.substring(0, 2);
                        var viewmode = $("input[name=viewmode]:checked").val();
                        var scale = $currentElement.find(".inputScale").val();
                        parameters.push({
                            "param": "EVEInfo" + customData.activeenergy,
                            "from": fromDate,
                            "viewmode": viewmode,
                            "to": toDate,
                            "scale": scale
                        });

                    };

                    if ($("#" + oData.id + "-AP").is(':checked')) {
                        var fromDate = $currentElement.find(".inputFromDate").val();
                        fromDate = fromDate.substring(6) + "-" + fromDate.substring(3, 5) + "-" + fromDate.substring(0, 2);
                        var toDate = $currentElement.find(".inputToDate").val();
                        toDate = toDate.substring(6) + "-" + toDate.substring(3, 5) + "-" + toDate.substring(0, 2);
                        var viewmode = $("input[name=viewmode]:checked").val();
                        var scale = $currentElement.find(".inputScale").val();
                        parameters.push({
                            "param": "EVEInfo" + customData.activepower,
                            "from": fromDate,
                            "viewmode": viewmode,
                            "to": toDate,
                            "scale": scale
                        });
                    };

                    if ($("#" + oData.id + "-RE").is(':checked')) {
                        var fromDate = $currentElement.find(".inputFromDate").val();
                        fromDate = fromDate.substring(6) + "-" + fromDate.substring(3, 5) + "-" + fromDate.substring(0, 2);
                        var toDate = $currentElement.find(".inputToDate").val();
                        toDate = toDate.substring(6) + "-" + toDate.substring(3, 5) + "-" + toDate.substring(0, 2);
                        var viewmode = $("input[name=viewmode]:checked").val();
                        var scale = $currentElement.find(".inputScale").val();
                        parameters.push({
                            "param": "EVEInfo" + customData.reactiveenergy,
                            "from": fromDate,
                            "viewmode": viewmode,
                            "to": toDate,
                            "scale": scale
                        });
                    };

                    if ($("#" + oData.id + "-RP").is(':checked')) {
                        var fromDate = $currentElement.find(".inputFromDate").val();
                        fromDate = fromDate.substring(6) + "-" + fromDate.substring(3, 5) + "-" + fromDate.substring(0, 2);
                        var toDate = $currentElement.find(".inputToDate").val();
                        toDate = toDate.substring(6) + "-" + toDate.substring(3, 5) + "-" + toDate.substring(0, 2);
                        var viewmode = $("input[name=viewmode]:checked").val();
                        var scale = $currentElement.find(".inputScale").val();
                        parameters.push({
                            "param": "EVEInfo" + customData.reactivepower,
                            "from": fromDate,
                            "viewmode": viewmode,
                            "to": toDate,
                            "scale": scale
                        });
                    };

                    if ($("#" + oData.id + "-PHY").is(':checked')) {
                        var fromDate = $currentElement.find(".inputFromDate").val();
                        fromDate = fromDate.substring(6) + "-" + fromDate.substring(3, 5) + "-" + fromDate.substring(0, 2);
                        var toDate = $currentElement.find(".inputToDate").val();
                        toDate = toDate.substring(6) + "-" + toDate.substring(3, 5) + "-" + toDate.substring(0, 2);
                        var viewmode = $("input[name=viewmode]:checked").val();
                        var scale = $currentElement.find(".inputScale").val();
                        parameters.push({
                            "param": "EVEInfo" + customData.cosphy,
                            "from": fromDate,
                            "viewmode": viewmode,
                            "to": toDate,
                            "scale": scale
                        });
                    };

                    /*			if (customData.reactiveenergy=="None") $("#"+oData.id+"-RE").attr("disabled", true);
								 if (customData.activepower=="None") $("#"+oData.id+"-AP").attr("disabled", true);
								 if (customData.reactivepower=="None") $("#"+oData.id+"-RP").attr("disabled", true);
								 if (customData.cosphy=="None") $("#"+oData.id+"-PHY").attr("disabled", true);
						 */
                } else {
                    var fromDate = $currentElement.find(".inputFromDate").val();
                    fromDate = fromDate.substring(6) + "-" + fromDate.substring(3, 5) + "-" + fromDate.substring(0, 2);
                    var toDate = $currentElement.find(".inputToDate").val();
                    toDate = toDate.substring(6) + "-" + toDate.substring(3, 5) + "-" + toDate.substring(0, 2);
                    var viewmode = $("input[name=viewmode]:checked").val();
                    var scale = $currentElement.find(".inputScale").val();
                    parameters.push({
                        "param": $currentElement.attr("component-id"),
                        "from": fromDate,
                        "viewmode": viewmode,
                        "to": toDate,
                        "scale": scale
                    });
                }




            }

        } else {
            $("#component-stats").empty();
            $("#component-more-stats").empty();
            var $status = $("#show-status");
            $status.text("Data not found");
            $("#show-status").show();
        }

        var p = JSON.stringify(parameters);
        var request = $.ajax({
            dataType: "json",
            url: URL_DATA,
            data: {
                id: 'Recorder_Base',
                params: p
            },
            cache: false,

            error: function(qXHR, textStatus, errorThrown) {
                console.debug(qXHR);
                console.debug(textStatus);
                console.debug(errorThrown);
            },

            success: function(e) {



                window.open("config/export.xlsx");
            }
        });
    });

});